local _G = _G
local date = _G.date
local MAJOR_VERSION = 'GraveLevelBar'

local LibStub = _G.LibStub
local AceAddon = LibStub('AceAddon-3.0')
local addon = AceAddon:GetAddon(MAJOR_VERSION)

local min = min

addon.repBarTemplate = {}
local repBarTemplate = addon.repBarTemplate

-- start xp
function repBarTemplate:getStartXPMin()
    return -42000
end

-- target level
function repBarTemplate:getTargetLevelMax()
    return #REP_DATA
end

function repBarTemplate:calcXpForLevel(level)
    assert(level <= 8,"level=" .. tostring(level))
    local sum = self:getStartXPMin()
    for i=1,level-1 do
        sum = sum + REP_DATA[i]
    end
    return sum
end

function repBarTemplate:calcLevelForXP(xp)
    local level = 1
    while xp > self:calcXpForLevel(level+1) do
        level = level + 1
    end
    local startXP = self:calcXpForLevel(level)
    assert(startXP <= xp,"level=" .. level .. " ,xp=" .. xp .. " ,startXP=" .. startXP)
    if startXP == xp then
        return level
    end
    local nextXP = self:calcXpForLevel(level+1)
    local fraction = (xp-startXP)/(nextXP-startXP)
    assert(0.0 <= fraction and fraction <= 1.0, "fraction=" .. fraction .. ", level=" .. level .. " ,xp=" .. xp .. " ,startXP=" .. startXP)
    return level + fraction
end


function addon:createRepModule(name,...)
    assert(addon.barTemplate.optionsTable.type)
    local template = addon:merge(addon.barTemplate, addon.xpBarTemplate)
    local template2 = addon:merge(template, repBarTemplate)
    assert(template2.optionsTable.type)
    template2.optionsTable.args.startXP.name = "Start Rep"
    template2.optionsTable.args.targetXP.name = "Target Rep"
    module = addon:NewModule(name,template2,'AceHook-3.0',...)
    return module
end

